#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glade/glade.h>
#include "libmpdclient.h"
#include "eggtrayicon.h"
#include "playlist.h"

#define CFG_NAME ".traympcfg"

#define CFG_AUTOCONNECT 	"autoconnect"
#define CFG_HIDE_MW 		"hide_mw"
#define CFG_IP			"ip"
#define CFG_PORT 		"port"
#define CFG_PLAYLIST_ADVANCED	"pl_adv"
#define CFG_PLAYLIST_FILTER	"pl_filt"
#define CFG_LAST_ERROR	"l_er"

config_struct config;

void read_config()
	{
	const gchar *home = g_getenv("HOME");
	char *path = NULL;
	if(home == NULL) return; /* can't get home. so I can cant read the config file */
	path = g_strdup_printf("%s/%s", home, CFG_NAME);
	if(g_file_test(path, G_FILE_TEST_EXISTS) && !g_file_test(path, G_FILE_TEST_IS_DIR))
		{
		FILE *fd;
		fd = fopen(path, "r");
		if(fd != NULL)
			{
				char buffer[256];
				bzero(buffer, 256);
				while(fgets(buffer, 256, fd))
					{	
						if(!strncmp(buffer, CFG_AUTOCONNECT, strlen(CFG_AUTOCONNECT)))
							{
							config.autoconnect = atoi(&buffer[strlen(CFG_AUTOCONNECT)]);
							}					
						else if(!strncmp(buffer, CFG_HIDE_MW, strlen(CFG_HIDE_MW)))
							{
							config.hide_mw = atoi(&buffer[strlen(CFG_HIDE_MW)]);
							}					
						else if(!strncmp(buffer, CFG_PORT, strlen(CFG_PORT)))
							{
							config.port = atoi(&buffer[strlen(CFG_PORT)]);
							}					
						else if(!strncmp(buffer, CFG_IP, strlen(CFG_IP)))
							{
							if(config.ip != NULL) g_free(config.ip);
							config.ip = g_strdup(g_strstrip(&buffer[strlen(CFG_IP)]));
							if(config.ip == NULL) config.ip = g_strdup("127.0.0.1");
							}				
						else if(!strncmp(buffer, CFG_PLAYLIST_ADVANCED, strlen(CFG_PLAYLIST_ADVANCED)))
							{
							insetting.show_advanced = atoi(&buffer[strlen(CFG_PLAYLIST_ADVANCED)]);
							}				
						else if(!strncmp(buffer, CFG_PLAYLIST_FILTER, strlen(CFG_PLAYLIST_FILTER)))
							{
							insetting.show_filter = atoi(&buffer[strlen(CFG_PLAYLIST_FILTER)]);
							}				
						else if(!strncmp(buffer, CFG_LAST_ERROR, strlen(CFG_LAST_ERROR)))
							{
							insetting.last_error = atoi(&buffer[strlen(CFG_LAST_ERROR)]);
							}		
						bzero(buffer, 256);
					}
		fclose(fd);
			}
		}
	g_free(path);
	}

void write_config()
	{
	const gchar *home = g_getenv("HOME");
	char *path = NULL;
	if(home == NULL) return; /* can't get home. so I can cant read the config file */
	path = g_strdup_printf("%s/%s", home, CFG_NAME);
	if( !g_file_test(path, G_FILE_TEST_IS_DIR))
		{
		FILE *fd;
		fd = fopen(path, "w");
		if(fd != NULL)
			{
				fprintf(fd, "# The IP/HOSTNAME to connect to\n");
				fprintf(fd, "%s  %s\n", CFG_IP, config.ip);
				fprintf(fd, "\n# The Port to connect on\n");
				fprintf(fd, "%s  %i\n", CFG_PORT, config.port);
				fprintf(fd, "\n# The following option causes traymp to connect directly on startup\n");
				fprintf(fd, "%s  %i\n", CFG_AUTOCONNECT, config.autoconnect);
				fprintf(fd, "\n# The Following option will hide the player window on startup.\n# Be very carefull with this function.\n# It doesnt check if there is a tray icon (not possible at that time)\n");
				fprintf(fd, "%s  %i\n", CFG_HIDE_MW, config.hide_mw);
				fprintf(fd, "\n\n# DO NOT TOUCH the following settings.\n");
				fprintf(fd, "%s  %i\n", CFG_PLAYLIST_ADVANCED, insetting.show_advanced);
				fprintf(fd, "%s  %i\n", CFG_PLAYLIST_FILTER, insetting.show_filter);
				fprintf(fd, "%s %i\n", CFG_LAST_ERROR, insetting.last_error);
				fclose(fd);
			}
	
		}
	g_free(path);
	}
