#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glade/glade.h>
#include "libmpdclient.h"
#include "eggtrayicon.h"
#include "playlist.h"

GtkListStore *playlists, *curlist, *searchlist;
GtkListStore *id3_artist, *id3_album, *id3_list;
GtkListStore *daf_dirs, *daf_files;

GladeXML *xml, *xml_progress;
void add_selected();
void fill_playlist_tree();
void playlist_row_selected(GtkTreeView *tree, GtkTreePath *path, GtkTreeViewColumn *col);
void clear_playlist();
void save_playlist();
void delete_playlist();
void shuffle_songs();
void delete_song();
void search_songs();
void search_toggle(GtkCellRendererToggle *cell, gchar *path_str);
void add_selected_search();
void search_select_with_state(GtkWidget *button, gboolean state);
void load_artists();
void load_albums();
void id_select_with_state(GtkWidget *button, gboolean state);
void load_directories(gchar *oldp);
void directory_row_selected(GtkTreeView *tree, GtkTreePath *path, GtkTreeViewColumn *col);
void add_selected_files();
void files_toggle(GtkCellRendererToggle *cell, gchar *path_str);
void load_songs_with_filter();
void dirs_toggle(GtkCellRendererToggle *cell, gchar *path_str);
void files_select_with_state(GtkWidget *button, gboolean state);
void playlist_row_activated(GtkWidget *wid);
void id_songs();
void id_toggle(GtkCellRendererToggle *cell, gchar *path_str);

void switch_advanced()
    {
	int height;
	gtk_window_get_size(GTK_WINDOW(glade_xml_get_widget(xml, "playlist_win")), NULL, &height);

   GtkRequisition requisition;
	gtk_widget_get_child_requisition
                                            (glade_xml_get_widget(xml, "vbox1"),
                                             &requisition);
    if(insetting.show_advanced)
	{
	insetting.show_advanced= FALSE;
	gtk_button_set_label(GTK_BUTTON(glade_xml_get_widget(xml, "advancedtb")),"Advanced");
	gtk_widget_hide_all(glade_xml_get_widget(xml, "notebook1"));
	gtk_window_resize(GTK_WINDOW(glade_xml_get_widget(xml, "playlist_win")), requisition.width,height);

	
	}
    else 
	{
	insetting.show_advanced= TRUE;
	gtk_button_set_label(GTK_BUTTON(glade_xml_get_widget(xml, "advancedtb")),"Simple");
	gtk_widget_show_all(glade_xml_get_widget(xml, "notebook1"));    
	}
    
    
    }

void filter_toggle()
    {
    if(insetting.show_filter)
	{
	insetting.show_filter= FALSE;
	gtk_arrow_set((GtkArrow *)glade_xml_get_widget(xml, "arrowfilter"),  GTK_ARROW_LEFT, GTK_SHADOW_IN);
	gtk_widget_hide_all(glade_xml_get_widget(xml, "filterbox"));
	if(strlen(gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xml, "entryfilter")))))load_songs_with_filter();
	}
    else 
	{
	insetting.show_filter= TRUE;
	gtk_arrow_set((GtkArrow *)glade_xml_get_widget(xml, "arrowfilter"),  GTK_ARROW_DOWN, GTK_SHADOW_IN);
	gtk_widget_show_all(glade_xml_get_widget(xml, "filterbox"));    
	if(strlen(gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xml, "entryfilter")))))load_songs_with_filter();
	}
    }


/***************************************/
/*   this are 2 function to create user feedback		 */
/***************************************/

GtkWidget *start_progress(char * text)
	{
	GtkWidget *progress = glade_xml_get_widget(xml, "progressbar");
	gtk_statusbar_push(GTK_STATUSBAR(glade_xml_get_widget(xml, "statusbar")), 0,text);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml, "hpaned1"), FALSE);
	insetting.update_timeout = FALSE;
	while (gtk_events_pending ()) gtk_main_iteration();
	return progress;
	}

void stop_progress()
	{
	gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(glade_xml_get_widget(xml,"progressbar")), 0);
	gtk_progress_bar_set_text(GTK_PROGRESS_BAR(glade_xml_get_widget(xml,"progressbar")), "");
	gtk_widget_set_sensitive(glade_xml_get_widget(xml, "hpaned1"), TRUE);
	gtk_statusbar_pop(GTK_STATUSBAR(glade_xml_get_widget(xml, "statusbar")), 0);
	insetting.update_timeout = TRUE;
	}

int playlist_manager_quit()
	{
	    /* if playlist is loading you just cant go out and kill it.. there for catch this signal and stop it */
	    if(!insetting.update_timeout)return TRUE;
		gtk_widget_destroy(glade_xml_get_widget(xml, "playlist_win"));
		/* remove all current items from the severall list's */
		gtk_list_store_clear(curlist);
		gtk_list_store_clear(playlists);
		gtk_list_store_clear(searchlist);
		gtk_list_store_clear(id3_artist);
		gtk_list_store_clear(id3_album);
		gtk_list_store_clear(id3_list);
		gtk_list_store_clear(daf_dirs);
		gtk_list_store_clear(daf_files);

		/* unref the lists .. dunno if this is needed */
		/* I wan't to get the whole playlist unloaded from memory if closed */
		g_object_unref(curlist);
		g_object_unref(playlists);
		g_object_unref(searchlist);
		g_object_unref(id3_artist);
		g_object_unref(id3_album);
		g_object_unref(id3_list);
		g_object_unref(daf_dirs);
		g_object_unref(daf_files);

		/* dunno about this */
		g_object_unref(xml);
	insetting.playlist_running = FALSE;
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlmw, "playmantb")), FALSE);
	return FALSE;
	}

/*** the playlist manager and alot off tree's ***/
void playlist_manager()
    {
    GtkWidget *tree;
    GtkCellRenderer *renderer;
	if(insetting.playlist_running) return;
	insetting.playlist_running = TRUE;
    xml = glade_xml_new(GLADE_PATH"playlist.glade", "playlist_win", NULL);
	if(xml == NULL) g_error("Can't load glade file. Please reinstall");
//    gtk_widget_show_all(glade_xml_get_widget(xml, "playlist_win"));

    
    /* connect signals */
    glade_xml_signal_autoconnect(xml);

    if(insetting.show_filter)
	{
	insetting.show_filter = FALSE;
	filter_toggle();
	}
    if(insetting.show_advanced)
	{
	insetting.show_advanced = FALSE;
	switch_advanced();
	}

    
    /* playlist treeview */
    playlists = gtk_list_store_new(1, GTK_TYPE_STRING);
    tree = glade_xml_get_widget(xml, "tree_playlists");
    gtk_tree_view_set_model(GTK_TREE_VIEW(tree),GTK_TREE_MODEL(playlists));
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Playlist", renderer, "text", 0, NULL);
	gtk_tree_view_column_set_sort_column_id(gtk_tree_view_get_column((GtkTreeView*)tree, 0), 0);
	/* the following function doesnt do what I want.. to bad */
 gtk_tree_sortable_set_sort_column_id
                                            ((GtkTreeSortable *)playlists,
                                             0,
                                             GTK_SORT_ASCENDING);
    
    /** songs in the current playlist **/
    curlist = gtk_list_store_new(6, GTK_TYPE_INT,GTK_TYPE_STRING, GTK_TYPE_STRING, GTK_TYPE_STRING, G_TYPE_BOOLEAN, GTK_TYPE_STRING);
    tree = glade_xml_get_widget(xml, "tree_playlist_songs");
    gtk_tree_view_set_model(GTK_TREE_VIEW(tree),GTK_TREE_MODEL(curlist));
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Title", renderer, "text", 1,"background-set", 4, "background", 5, NULL);
    gtk_tree_view_column_set_resizable(gtk_tree_view_get_column((GtkTreeView*)tree, 0), TRUE);
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Artist", renderer, "text", 2,"background-set", 4, "background", 5, NULL);
    gtk_tree_view_column_set_resizable(gtk_tree_view_get_column((GtkTreeView*)tree, 1), TRUE);
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Album", renderer, "text", 3,"background-set", 4, "background", 5, NULL);
    gtk_tree_view_column_set_resizable(gtk_tree_view_get_column((GtkTreeView*)tree, 2), TRUE);    
	/**** searchlist ****/
	 searchlist = gtk_list_store_new(5, GTK_TYPE_STRING,GTK_TYPE_INT,GTK_TYPE_STRING, GTK_TYPE_STRING, GTK_TYPE_STRING);
     tree = glade_xml_get_widget(xml, "tree_search");
    gtk_tree_view_set_model(GTK_TREE_VIEW(tree),GTK_TREE_MODEL(searchlist));
	renderer = gtk_cell_renderer_toggle_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Select", renderer, "active", 1, NULL);
	g_signal_connect(G_OBJECT(renderer), "toggled", G_CALLBACK(search_toggle), NULL);
	renderer = gtk_cell_renderer_text_new();

    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Title", renderer, "text", 2, NULL);
    gtk_tree_view_column_set_resizable(gtk_tree_view_get_column((GtkTreeView*)tree, 0), TRUE);
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Artist", renderer, "text", 3, NULL);
    gtk_tree_view_column_set_resizable(gtk_tree_view_get_column((GtkTreeView*)tree, 1), TRUE);
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Album", renderer, "text", 4, NULL);
    gtk_tree_view_column_set_resizable(gtk_tree_view_get_column((GtkTreeView*)tree, 2), TRUE);    


    /* artist tree */
    id3_artist = gtk_list_store_new(1, GTK_TYPE_STRING);
    tree = glade_xml_get_widget(xml, "tree_artist");
    gtk_tree_view_set_model(GTK_TREE_VIEW(tree),GTK_TREE_MODEL(id3_artist));
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Artist", renderer, "text", 0, NULL);
    gtk_tree_view_column_set_sort_column_id(gtk_tree_view_get_column((GtkTreeView*)tree, 0), 0);
   /* album tree */
    id3_album = gtk_list_store_new(1, GTK_TYPE_STRING);
    tree = glade_xml_get_widget(xml, "tree_album");
    gtk_tree_view_set_model(GTK_TREE_VIEW(tree),GTK_TREE_MODEL(id3_album));
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Album", renderer, "text", 0, NULL);
    gtk_tree_view_column_set_sort_column_id(gtk_tree_view_get_column((GtkTreeView*)tree, 0), 0);
	/**** idlist ****/
	 id3_list = gtk_list_store_new(5, GTK_TYPE_STRING,GTK_TYPE_INT,GTK_TYPE_STRING, GTK_TYPE_STRING, GTK_TYPE_STRING);
     tree = glade_xml_get_widget(xml, "tree_id");
    gtk_tree_view_set_model(GTK_TREE_VIEW(tree),GTK_TREE_MODEL(id3_list));
	renderer = gtk_cell_renderer_toggle_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Select", renderer, "active", 1, NULL);
	g_signal_connect(G_OBJECT(renderer), "toggled", G_CALLBACK(id_toggle), NULL);
	renderer = gtk_cell_renderer_text_new();

    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Title", renderer, "text", 2, NULL);
    gtk_tree_view_column_set_resizable(gtk_tree_view_get_column((GtkTreeView*)tree, 0), TRUE);
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Artist", renderer, "text", 3, NULL);
    gtk_tree_view_column_set_resizable(gtk_tree_view_get_column((GtkTreeView*)tree, 1), TRUE);
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Album", renderer, "text", 4, NULL);
    gtk_tree_view_column_set_resizable(gtk_tree_view_get_column((GtkTreeView*)tree, 2), TRUE);    

	/* the directory and files view */
	gtk_entry_set_text(GTK_ENTRY(glade_xml_get_widget(xml, "path_entry")), "/");
	/* directory */
	 daf_dirs = gtk_list_store_new(4, GTK_TYPE_STRING, GTK_TYPE_STRING, GTK_TYPE_INT, GTK_TYPE_INT);
     tree = glade_xml_get_widget(xml, "tree_dir");
    gtk_tree_view_set_model(GTK_TREE_VIEW(tree),GTK_TREE_MODEL(daf_dirs));
	renderer = gtk_cell_renderer_toggle_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Select", renderer, "active", 2,"activatable", 3, NULL);
	g_signal_connect(G_OBJECT(renderer), "toggled", G_CALLBACK(dirs_toggle), NULL);
	renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Directory", renderer, "text", 1, NULL);
    gtk_tree_view_column_set_resizable(gtk_tree_view_get_column((GtkTreeView*)tree, 0), TRUE);

	/* files tree */
	 daf_files = gtk_list_store_new(5, GTK_TYPE_STRING,GTK_TYPE_INT,GTK_TYPE_STRING, GTK_TYPE_STRING, GTK_TYPE_STRING);
     tree = glade_xml_get_widget(xml, "tree_files");
    gtk_tree_view_set_model(GTK_TREE_VIEW(tree),GTK_TREE_MODEL(daf_files));
	renderer = gtk_cell_renderer_toggle_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Select", renderer, "active", 1, NULL);
	g_signal_connect(G_OBJECT(renderer), "toggled", G_CALLBACK(files_toggle), NULL);
	renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Title", renderer, "text", 2, NULL);
    gtk_tree_view_column_set_resizable(gtk_tree_view_get_column((GtkTreeView*)tree, 0), TRUE);
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Artist", renderer, "text", 3, NULL);
    gtk_tree_view_column_set_resizable(gtk_tree_view_get_column((GtkTreeView*)tree, 1), TRUE);
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(tree), -1, "Album", renderer, "text", 4, NULL);
    gtk_tree_view_column_set_resizable(gtk_tree_view_get_column((GtkTreeView*)tree, 2), TRUE);    

	/* some extra signals */
	tree = glade_xml_get_widget(xml, "search_select_all");
	g_signal_connect(G_OBJECT(tree), "clicked", G_CALLBACK(search_select_with_state), GINT_TO_POINTER(TRUE));
	tree = glade_xml_get_widget(xml, "search_select_none");
	g_signal_connect(G_OBJECT(tree), "clicked", G_CALLBACK(search_select_with_state), FALSE);	

	/* some extra signals */
	tree = glade_xml_get_widget(xml, "id_select_all");
	g_signal_connect(G_OBJECT(tree), "clicked", G_CALLBACK(id_select_with_state), GINT_TO_POINTER(TRUE));
	tree = glade_xml_get_widget(xml, "id_select_none");
	g_signal_connect(G_OBJECT(tree), "clicked", G_CALLBACK(id_select_with_state), FALSE);	

	/* some extra signals */
	tree = glade_xml_get_widget(xml, "files_select_all");
	g_signal_connect(G_OBJECT(tree), "clicked", G_CALLBACK(files_select_with_state), GINT_TO_POINTER(TRUE));
	tree = glade_xml_get_widget(xml, "files_select_none");
	g_signal_connect(G_OBJECT(tree), "clicked", G_CALLBACK(files_select_with_state), FALSE);	

	while (gtk_events_pending ()) gtk_main_iteration();
	/** fill the current list **/
    fill_playlist_tree();
    load_songs_with_filter();
    load_artists();
    load_directories(NULL);
    }
    
/***************************************/
/* PLAYLIST TREE  											 */
/***************************************/

void fill_playlist_tree()
    {
	mpd_InfoEntity *entity;
	GtkWidget *progress = start_progress("Filling Playlist list");
	gtk_list_store_clear(playlists);
	while (gtk_events_pending ()) gtk_main_iteration();
	mpd_sendLsInfoCommand(connection,"");
	check_error();
	while((entity = mpd_getNextInfoEntity(connection))) {
	check_error();
	if(entity->type== MPD_INFO_ENTITY_TYPE_PLAYLISTFILE) {
		mpd_PlaylistFile * pl = 
		entity->info.playlistFile;
		GtkTreeIter iter;
		gtk_list_store_append(playlists, &iter);
		gtk_list_store_set(playlists, &iter, 0, pl->path, -1);
		gtk_progress_bar_pulse(GTK_PROGRESS_BAR(progress));
		while (gtk_events_pending ()) gtk_main_iteration();
		}
	mpd_freeInfoEntity(entity);
	}
	stop_progress();
    }


void playlist_row_selected(GtkTreeView *tree, GtkTreePath *path, GtkTreeViewColumn *col)
    {
    GtkTreeIter iter;
    GtkWidget *entry;
    char *buf;
    gtk_tree_model_get_iter(GTK_TREE_MODEL(playlists),  &iter, path);
    gtk_tree_model_get(GTK_TREE_MODEL(playlists), &iter, 0, &buf, -1);
    entry = glade_xml_get_widget(xml, "playlist_name");
    gtk_entry_set_text((GtkEntry *)entry, buf);
    mpd_sendClearCommand(connection);
	check_error();
    mpd_finishCommand(connection);
    check_error();
    mpd_sendLoadCommand(connection, buf);
    check_error();
    mpd_finishCommand(connection);
    check_error();
    //fill_playlist_songs();
    }

/********************************/
/* CURRENT SONGS							   */
/********************************/
/* clears the current playlist */
void clear_playlist()
    {
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
    mpd_sendClearCommand(connection);
	check_error();
    mpd_finishCommand(connection);    
	insetting.update_timeout = TRUE;
    }
/* save's the playlist (name is from entry box */
void save_playlist()
    {
	GtkTreeIter iter;
	GtkTreeModel *model = GTK_TREE_MODEL(playlists);
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
    GtkWidget *entry = glade_xml_get_widget(xml, "playlist_name");    
    const gchar *buf = gtk_entry_get_text(GTK_ENTRY(entry));
    if(strlen(buf) == 0) return;
	if(gtk_tree_model_get_iter_first(model, &iter))
		{
		do	
			{
				char *buf1;
				gtk_tree_model_get(model, &iter, 0, &buf1, -1);
				if(!strcmp(buf1, buf))
					{
					GladeXML *esf =  glade_xml_new(GLADE_PATH"playlist.glade", "savedialog", NULL);
					GtkWidget *dialog = glade_xml_get_widget(esf, "savedialog");
					switch(gtk_dialog_run(GTK_DIALOG(dialog)))
						{
						case GTK_RESPONSE_YES:
								mpd_sendRmCommand(connection, (char *)buf);
								check_error();
								mpd_finishCommand(connection);
								check_error();
								break;
						default:
								gtk_widget_destroy(dialog);
								g_object_unref(esf);
								insetting.update_timeout = TRUE;
								return;
						}
					gtk_widget_destroy(dialog);
					g_object_unref(esf);
					}
			}while(gtk_tree_model_iter_next(model, &iter));
		}
    mpd_sendSaveCommand(connection, (char *)buf);
	check_error();
    mpd_finishCommand(connection);    
	check_error();    
    fill_playlist_tree();
	insetting.update_timeout = TRUE;
    }

/** remove's the selected playlist */
void delete_playlist()
    {
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    GtkWidget *tree = glade_xml_get_widget(xml, "tree_playlists");
    GtkTreeModel *model = GTK_TREE_MODEL(playlists);
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(tree));
    if(gtk_tree_selection_get_selected(selection, &model, &iter))
	{
	gchar *buf;
	gtk_tree_model_get(model, &iter, 0, &buf, -1);	
	mpd_sendRmCommand(connection, buf);
	check_error();
	mpd_finishCommand(connection);    	
	check_error();	
	fill_playlist_tree();
	}
    else g_warning("No selection to delete");
	insetting.update_timeout = TRUE;
    }
    
/** shuffles the current playlist **/
void shuffle_songs()
    {
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
    mpd_sendShuffleCommand(connection);
	check_error();
    mpd_finishCommand(connection);    	
	check_error();
	insetting.update_timeout = TRUE;
    }

/** delete's a the selected song from the current playlist */
void delete_song()
    {
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    GtkWidget *tree = glade_xml_get_widget(xml, "tree_playlist_songs");
    GtkTreeModel *model = GTK_TREE_MODEL(curlist);
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(tree));
    if(gtk_tree_selection_get_selected(selection, &model, &iter))
	{
	int song;
	gtk_tree_model_get(model, &iter, 0, &song, -1);	
	g_print("**DEBUG** delete song %i\n", song);
	mpd_sendDeleteCommand(connection, song);
	check_error();
	mpd_finishCommand(connection);    	
	check_error();
	}
    else g_warning("No selection to delete");
	insetting.update_timeout = TRUE;
    }

/** this searches for a songs and add's them to the search tree */
void search_songs()
	{
	mpd_InfoEntity *entity;
	gtk_list_store_clear(searchlist);
	GtkWidget *entry;
	GtkWidget *progress = start_progress("Loading search results");
	int i=0, option =0;
	entry = glade_xml_get_widget(xml, "search_entry");
	const gchar *entryb = gtk_entry_get_text(GTK_ENTRY(entry));
	if(gtk_option_menu_get_history(GTK_OPTION_MENU(glade_xml_get_widget(xml, "search_type_selector"))) == 0) option = MPD_TABLE_ARTIST;
	else if (gtk_option_menu_get_history(GTK_OPTION_MENU(glade_xml_get_widget(xml, "search_type_selector"))) == 1) option = MPD_TABLE_ALBUM;
	else if (gtk_option_menu_get_history(GTK_OPTION_MENU(glade_xml_get_widget(xml, "search_type_selector"))) == 2) option = MPD_TABLE_TITLE;
	else if (gtk_option_menu_get_history(GTK_OPTION_MENU(glade_xml_get_widget(xml, "search_type_selector"))) == 3) option = MPD_TABLE_FILENAME;

	/* get all items in the playlist */
	mpd_sendSearchCommand(connection, option, (char *)entryb);
	check_error();
	while((entity = mpd_getNextInfoEntity(connection)))
			{
			GtkTreeIter iter;
	check_error();
			char *buf = g_path_get_basename(entity->info.song->file);
			if(!(i % 50))
				{
				gtk_progress_bar_pulse(GTK_PROGRESS_BAR(progress));
				while (gtk_events_pending ())gtk_main_iteration();
				}
			gtk_list_store_append(searchlist, &iter);
			if(entity->info.song->title == NULL)
				{
				gchar *utf8 =  g_locale_to_utf8(buf, -1, NULL ,NULL ,NULL);
				gchar *utf82 = g_locale_to_utf8(entity->info.song->file, -1, NULL ,NULL ,NULL);
				gtk_list_store_set(searchlist, &iter,0, utf82,2,utf8,-1);
				g_free(utf82);
				g_free(utf8);
				}
			else
				{
				gchar *utf8 =  g_locale_to_utf8(entity->info.song->title, -1, NULL ,NULL ,NULL);
				gchar *utf82 = g_locale_to_utf8(entity->info.song->file, -1, NULL ,NULL ,NULL);
				gtk_list_store_set(searchlist, &iter,0, utf82,2,utf8,-1);
				g_free(utf82);
				g_free(utf8);
				}
			if(entity->info.song->artist != NULL)				
				{
				gchar *utf8 =  g_locale_to_utf8(entity->info.song->artist, -1, NULL ,NULL ,NULL);
				gtk_list_store_set(searchlist, &iter,3,utf8,-1);
				g_free(utf8);
				}
			if(entity->info.song->album != NULL)	
				{
				gchar *utf8 =  g_locale_to_utf8(entity->info.song->album, -1, NULL ,NULL ,NULL);
				gtk_list_store_set(searchlist, &iter,4,utf8,-1);
				g_free(utf8);
				}
			g_free(buf);
			mpd_freeInfoEntity(entity);
			i++;
			}	
	stop_progress();
	}

/** toggles in the search tree the toggle entry if clicked */
void search_toggle(GtkCellRendererToggle *cell, gchar *path_str)
    {
    GtkTreeIter iter;
    GtkTreeModel *model = GTK_TREE_MODEL(searchlist);
    gint value;

    GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  	/* get toggled iter */
    gtk_tree_model_get_iter (model, &iter, path);
	      
    gtk_tree_model_get(model, &iter,1,&value, -1);
    gtk_list_store_set(searchlist, &iter, 1, !value, -1);   
    }

/** This functions add the songs that are selected in the search window to the current playlist and reloads that view **/
void add_selected_search()
	{
	GtkTreeIter iter;
	GtkTreeModel *model = GTK_TREE_MODEL(searchlist);
	char *file;
	int value=0, i=0;
	GtkWidget *progress = start_progress("Adding selected songs from search results");
	if(!gtk_tree_model_get_iter_first(model, &iter))
		{
		stop_progress();
		return;
		}
	do{
		gtk_tree_model_get(model, &iter, 0, &file, 1, &value,-1);
			i++;
			if(!(i % 10))
				{
				gtk_progress_bar_pulse(GTK_PROGRESS_BAR(progress));
				while (gtk_events_pending ())gtk_main_iteration();
				}
		if(value)
				{
				mpd_sendAddCommand(connection, file);
				check_error();
				mpd_finishCommand(connection);
				check_error();
				}
		}while(gtk_tree_model_iter_next(model, &iter));
	stop_progress();
	}

/** This function selects or deselect all entry's in the search list **/
void search_select_with_state(GtkWidget *button, gboolean state)
	{
	GtkTreeIter iter;
	GtkTreeModel *model = GTK_TREE_MODEL(searchlist);
	if(!gtk_tree_model_get_iter_first(model, &iter)) return;
	do{
		gtk_list_store_set(searchlist, &iter, 1, state,-1);
		}while(gtk_tree_model_iter_next(model, &iter));
	}

void load_artists()
    {
	char *buf;
	GtkTreeIter iter;
	GtkTreeModel *model = GTK_TREE_MODEL(id3_artist);
	GtkWidget *progress = start_progress("Loading artists");
	int i =0;
	gtk_list_store_clear(id3_artist);

/*	gtk_list_store_append(id3_artist, &iter);
	gtk_list_store_set(id3_artist, &iter, 0, "All", -1);
*/	mpd_sendListCommand(connection, MPD_TABLE_ARTIST, NULL);
	check_error();
	while((buf = mpd_getNextArtist(connection))) {
		gchar *utf8 = g_locale_to_utf8(buf, -1, NULL ,NULL ,NULL);
	check_error();
			i++;
			if(!(i % 50))
				{
				gtk_progress_bar_pulse(GTK_PROGRESS_BAR(progress));
				while (gtk_events_pending ())gtk_main_iteration();
				}
		gtk_list_store_append(id3_artist, &iter);
		if(utf8 != NULL && g_utf8_strlen(utf8,-1)==0)
			{
			if(utf8)g_free(utf8);
			utf8 = g_strdup("no name");
			}
		else if (utf8 == NULL) utf8 = g_strdup("no name");
		if(utf8 == NULL) g_print("error in artist: %s\n", buf);

		gtk_list_store_set(id3_artist, &iter, 0, utf8, -1);
		g_free(utf8);
	g_free(buf);
	}
	stop_progress();
	if(gtk_tree_model_get_iter_first(model, &iter))
	    {
		GtkTreeSelection *selection = gtk_tree_view_get_selection((GtkTreeView *)glade_xml_get_widget(xml, "tree_artist"));	    
		gtk_tree_selection_select_iter(selection, &iter);
		load_albums();
	    }
	
    }

void load_albums()
    {
	char *buf, *artist;
	gtk_list_store_clear(id3_album);
	GtkTreeIter iter;
	GtkTreeModel *model = GTK_TREE_MODEL(id3_artist);
	GtkTreeSelection *selection = gtk_tree_view_get_selection((GtkTreeView *)glade_xml_get_widget(xml, "tree_artist"));
	GtkWidget *progress = start_progress("Loading albums");
	int i =0;
	if(!gtk_tree_selection_get_selected(selection, &model, &iter)) return;
	else gtk_tree_model_get(model , &iter, 0,&artist,-1);
	if(!strcmp(artist, "All")) mpd_sendListCommand(connection, MPD_TABLE_ALBUM, NULL);
	else 	mpd_sendListCommand(connection,MPD_TABLE_ALBUM, artist);
	if(connection->error) g_print("%s\n", connection->errorStr);
		check_error();
	gtk_list_store_append(id3_album, &iter);
	gtk_list_store_set(id3_album, &iter, 0, "All", -1);
	while((buf = mpd_getNextAlbum(connection))) {
		GtkTreeIter iter;
		gchar *utf8 = NULL;
	check_error();
			i++;
			if(!(i % 10))
				{
				gtk_progress_bar_pulse(GTK_PROGRESS_BAR(progress));
				while (gtk_events_pending ())gtk_main_iteration();
				}
		if(buf != NULL && strlen(buf)) 
		utf8 = g_locale_to_utf8(buf, -1, NULL ,NULL ,NULL);
		gtk_list_store_append(id3_album, &iter);
		if(utf8 != NULL && g_utf8_strlen(utf8, -1)==0)
			{
			if(utf8) g_free(utf8);
			g_print("no album name\n");
			utf8 = g_strdup("no name");
			}
		else if (utf8 == NULL) utf8 = g_strdup("no name");
		if(utf8 == NULL) g_print("error album: %s\n", buf);
		gtk_list_store_set(id3_album, &iter, 0, utf8, -1);
	g_free(utf8);
	g_free(buf);
	}
	stop_progress();
	model = GTK_TREE_MODEL(id3_album);
	if(gtk_tree_model_get_iter_first(model, &iter))
	    {
		GtkTreeSelection *selection = gtk_tree_view_get_selection((GtkTreeView *)glade_xml_get_widget(xml, "tree_album"));	    
		gtk_tree_selection_select_iter(selection, &iter);
		id_songs();
	    }
    }


/** this searches for a songs and add's them to the search tree */
void id_songs()
	{
	mpd_InfoEntity *entity;
	gchar *artist, *album, *buf;
	GtkTreeIter iter;
	GtkTreeSelection *selection;
	GtkTreeModel *model;
	int i =0;
	GtkWidget *progress = start_progress("Loading songs");
	gtk_list_store_clear(id3_list);


	/* get the artist name */
	model = GTK_TREE_MODEL(id3_artist);
	selection = gtk_tree_view_get_selection((GtkTreeView *)glade_xml_get_widget(xml, "tree_artist"));
	if(!gtk_tree_selection_get_selected(selection, &model, &iter)) return;
	else gtk_tree_model_get(model, &iter, 0, &buf, -1);
	artist = g_strdup(buf);

	/* get the album name */
	model = GTK_TREE_MODEL(id3_album);
	selection = gtk_tree_view_get_selection((GtkTreeView *)glade_xml_get_widget(xml, "tree_album"));
	if(!gtk_tree_selection_get_selected(selection, &model, &iter)) return;
	else gtk_tree_model_get(model, &iter, 0, &buf, -1);
	album = g_strdup(buf);
	/* get all items in the playlist */
	if(!strcmp(album, "no name"))
	    {
	     g_free(album);
	     album = g_strdup("");
	    }
	mpd_sendFindCommand(connection, MPD_TABLE_ARTIST, artist);
	check_error();
	while((entity = mpd_getNextInfoEntity(connection)))
			{
			GtkTreeIter iter;
	check_error();
			i++;
			if(!(i % 50))
				{
				gtk_progress_bar_pulse(GTK_PROGRESS_BAR(progress));
				while (gtk_events_pending ())gtk_main_iteration();
				}
			if(TRUE) /* entity->info.song->album != NULL)*/
			{
			gchar *utf8;
			if(entity->info.song->album != NULL)
				{
				 utf8 =  g_locale_to_utf8(entity->info.song->album, -1, NULL ,NULL ,NULL);
				}
			else utf8 = g_strdup("");
			if(!g_utf8_collate(album, utf8) || !g_utf8_collate(album, "All"))
			{
			gtk_list_store_append(id3_list, &iter);
			if(entity->info.song->title != NULL )
				{
				gchar *utf8 =  g_locale_to_utf8(entity->info.song->title, -1, NULL ,NULL ,NULL);
				gchar *utf82 = g_locale_to_utf8(entity->info.song->file, -1, NULL ,NULL ,NULL);
				if(utf8 != NULL && utf82 != NULL)gtk_list_store_set(id3_list, &iter,0, utf82,2,utf8,-1);
				g_free(utf82);
				g_free(utf8);
				}	
			else if(entity->info.song->file != NULL )
				{
				char *buf1 = g_path_get_basename(entity->info.song->file);
				gchar *utf8 = g_locale_to_utf8(buf1, -1, NULL ,NULL ,NULL);
				gchar *utf82 = g_locale_to_utf8(entity->info.song->file, -1, NULL ,NULL ,NULL);
				if(buf1 != NULL) g_free(buf1);
				if(utf8 != NULL && utf82 != NULL)gtk_list_store_set(id3_list, &iter,0, utf82,2,utf8,-1);
				g_free(utf82);
				g_free(utf8);
				}	
			if(entity->info.song->artist != NULL)			
				{
				gchar *utf8 =  g_locale_to_utf8(entity->info.song->artist, -1, NULL ,NULL ,NULL);
				if(utf8 != NULL)gtk_list_store_set(id3_list, &iter,3,utf8,-1);
				g_free(utf8);
				}
			if(entity->info.song->album != NULL) 
				{
				gchar *utf8 =  g_locale_to_utf8(entity->info.song->album, -1, NULL ,NULL ,NULL);
				if(utf8 != NULL)gtk_list_store_set(id3_list, &iter,4,utf8,-1);
				g_free(utf8);
				}
			}
			g_free(utf8);
			}
			mpd_freeInfoEntity(entity);
			}
	if(album != NULL) g_free(album);
	if(artist != NULL) 	g_free(artist);
	stop_progress();
	}

/** toggles in the search tree the toggle entry if clicked */
void id_toggle(GtkCellRendererToggle *cell, gchar *path_str)
    {
    GtkTreeIter iter;
    GtkTreeModel *model = GTK_TREE_MODEL(id3_list);
    gint value;

    GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  	/* get toggled iter */
    gtk_tree_model_get_iter (model, &iter, path);
	      
    gtk_tree_model_get(model, &iter,1,&value, -1);
    gtk_list_store_set(id3_list, &iter, 1, !value, -1);   
    }

/** This function selects or deselect all entry's in the search list **/
void id_select_with_state(GtkWidget *button, gboolean state)
	{
	GtkTreeIter iter;
	GtkTreeModel *model = GTK_TREE_MODEL(id3_list);
	if(!gtk_tree_model_get_iter_first(model, &iter)) return;
	do{
		gtk_list_store_set(id3_list, &iter, 1, state,-1);
		}while(gtk_tree_model_iter_next(model, &iter));
	}


/** This functions add the songs that are selected in the search window to the current playlist and reloads that view **/
void add_selected_id()
	{
	GtkTreeIter iter;
	GtkTreeModel *model = GTK_TREE_MODEL(id3_list);
	char *file;
	int value=0, i = 0;
	GtkWidget *progress = start_progress("Add selected songs");
	if(!gtk_tree_model_get_iter_first(model, &iter))
		{
		stop_progress();
		return;
		}
	do{
		gtk_tree_model_get(model, &iter, 0, &file, 1, &value,-1);
		if(value)
				{
			i++;
			if(!(i % 50))
				{
				gtk_progress_bar_pulse(GTK_PROGRESS_BAR(progress));
				while (gtk_events_pending ())gtk_main_iteration();
				}
				mpd_sendAddCommand(connection, file);
				check_error();
				mpd_finishCommand(connection);
				check_error();
				}
		}while(gtk_tree_model_iter_next(model, &iter));
	stop_progress();
	}


/* load the directorie's in the current path */
void load_directories(gchar *oldp)
	{
	const gchar *path = gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xml, "path_entry")));
	mpd_InfoEntity *entity;
	GtkTreeIter iter;
	GtkWidget *progress = start_progress("Loading directory's & files");
	int i = 0;
	gtk_list_store_clear(daf_files);
	gtk_list_store_clear(daf_dirs);
	if(oldp != NULL)if(strcmp(path, "/")) 
			{
			gtk_list_store_append(daf_dirs, &iter);
			gtk_list_store_set(daf_dirs, &iter, 0,oldp , 1, "../",2,0, 3, 0,-1);
			}

	mpd_sendLsInfoCommand(connection , (char *)path);
	check_error();
	while ((entity = mpd_getNextInfoEntity(connection)))
			{
	check_error();
			i++;
			if(!(i % 20))
				{
				gtk_progress_bar_pulse(GTK_PROGRESS_BAR(progress));
				while (gtk_events_pending ())gtk_main_iteration();
				}
			if(entity->type == MPD_INFO_ENTITY_TYPE_DIRECTORY)
				{	
				
				gchar *utf8;
				gchar *base;
				gtk_list_store_append(daf_dirs, &iter);
				utf8 = g_locale_to_utf8(entity->info.directory->path, -1, NULL ,NULL ,NULL);
				base = g_path_get_basename(utf8);
				gtk_list_store_set(daf_dirs, &iter, 0,utf8 , 1, base,2,0,3,1,-1);
				g_free(base);
				g_free(utf8);
				}
			else if(entity->type == MPD_INFO_ENTITY_TYPE_SONG)
			{
			gtk_list_store_append(daf_files, &iter);
			if(entity->info.song->title == NULL)
				{
				gchar *utf82 = g_locale_to_utf8(entity->info.song->file, -1, NULL ,NULL ,NULL);
				gchar *utf8 = NULL;
				utf8 = g_path_get_basename(utf82);
				gtk_list_store_set(daf_files, &iter,0, utf82,2,utf8,-1);
				g_free(utf82);
				g_free(utf8);
				}
			else
				{
				gchar *utf8 =  g_locale_to_utf8(entity->info.song->title, -1, NULL ,NULL ,NULL);
				gchar *utf82 = g_locale_to_utf8(entity->info.song->file, -1, NULL ,NULL ,NULL);
				gtk_list_store_set(daf_files, &iter,0, utf82,2,utf8,-1);
				g_free(utf82);
				g_free(utf8);
				}
			if(entity->info.song->artist != NULL)				
				{
				gchar *utf8 =  g_locale_to_utf8(entity->info.song->artist, -1, NULL ,NULL ,NULL);
				gtk_list_store_set(daf_files, &iter,3,utf8,-1);
				g_free(utf8);
				}
			if(entity->info.song->album != NULL)	
				{
				gchar *utf8 =  g_locale_to_utf8(entity->info.song->album, -1, NULL ,NULL ,NULL);
				gtk_list_store_set(daf_files, &iter,4,utf8,-1);
				g_free(utf8);
				}
				}
				mpd_freeInfoEntity(entity);
			}
	stop_progress();
	}

void directory_row_selected(GtkTreeView *tree, GtkTreePath *path, GtkTreeViewColumn *col)
    {
    GtkTreeIter iter;
    GtkWidget *entry;
    char *buf, *new_buf;
    gtk_tree_model_get_iter(GTK_TREE_MODEL(daf_dirs),  &iter, path);
    gtk_tree_model_get(GTK_TREE_MODEL(daf_dirs), &iter, 0, &buf, -1);
    entry = glade_xml_get_widget(xml, "path_entry");
  	new_buf = g_strdup_printf("%s",  buf);
	gtk_entry_set_text(GTK_ENTRY(entry), new_buf);
	buf = g_path_get_dirname(new_buf);
	if(!strcmp(buf, "."))
		{
		g_free(buf);
		buf = g_strdup("/");
		}
	load_directories(buf);
    g_free(new_buf);
	g_free(buf);
	}

/** This functions add the songs that are selected in the files tree to the current playlist and reloads that view **/
void add_selected_files()
	{
	GtkTreeIter iter;
	GtkTreeModel *model = GTK_TREE_MODEL(daf_files);
	char *file;
	int value=0, i = 0;
	GtkWidget *progress = start_progress("Adding selected songs");
	if(!gtk_tree_model_get_iter_first(model, &iter))
			{
			stop_progress();
			return;
			}
	do{
		gtk_tree_model_get(model, &iter, 0, &file, 1, &value,-1);
			i++;
			if(!(i % 20))
				{
				gtk_progress_bar_pulse(GTK_PROGRESS_BAR(progress));
				while (gtk_events_pending ())gtk_main_iteration();
				}
		if(value)
				{
				mpd_sendAddCommand(connection, file);
				check_error();
				mpd_finishCommand(connection);
				check_error();
				}
		}while(gtk_tree_model_iter_next(model, &iter));
	stop_progress();
	}

/** toggles in the files tree the toggle entry if clicked */
void files_toggle(GtkCellRendererToggle *cell, gchar *path_str)
    {
    GtkTreeIter iter;
    GtkTreeModel *model = GTK_TREE_MODEL(daf_files);
    gint value;

    GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  	/* get toggled iter */
    gtk_tree_model_get_iter (model, &iter, path);
	      
    gtk_tree_model_get(model, &iter,1,&value, -1);
    gtk_list_store_set(daf_files, &iter, 1, !value, -1);   
    }

/** This function selects or deselect all entry's in the search list **/
void files_select_with_state(GtkWidget *button, gboolean state)
	{
	GtkTreeIter iter;
	GtkTreeModel *model = GTK_TREE_MODEL(daf_files);
	if(!gtk_tree_model_get_iter_first(model, &iter)) return;
	do{
		gtk_list_store_set(daf_files, &iter, 1, state,-1);
		}while(gtk_tree_model_iter_next(model, &iter));
	}

/* selecting files */
void dirs_toggle(GtkCellRendererToggle *cell, gchar *path_str)
    {
    GtkTreeIter iter;
    GtkTreeModel *model = GTK_TREE_MODEL(daf_dirs);
    gint value;

    GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  	/* get toggled iter */
    gtk_tree_model_get_iter (model, &iter, path);
	      
    gtk_tree_model_get(model, &iter,2,&value, -1);
    gtk_list_store_set(daf_dirs, &iter, 2, !value, -1);   
    }


/** This functions add the songs that are selected in the files tree to the current playlist and reloads that view **/
void add_selected_dirs()
	{
	GtkTreeIter iter;
	GtkTreeModel *model = GTK_TREE_MODEL(daf_dirs);
	GSList *glist=NULL;
	char *file;
	int value=0, i= 0;
	GtkWidget *progress = start_progress("Adding selected directory's recursively");
	if(!gtk_tree_model_get_iter_first(model, &iter))
			{
			stop_progress();
			return;
			}
	do{
		    i++;
			if(!(i % 50))
				{
				gtk_progress_bar_pulse(GTK_PROGRESS_BAR(progress));
				while (gtk_events_pending ())gtk_main_iteration();
				}

		gtk_tree_model_get(model, &iter, 0, &file, 2, &value,-1);
		
		if(value)
				{
				mpd_InfoEntity *entity;
				mpd_sendListallCommand(connection, file);
				check_error();
				while((entity = mpd_getNextInfoEntity(connection)))
				    {
					check_error();
				    i++;
				    if(!(i % 50))
					{
					gtk_progress_bar_pulse(GTK_PROGRESS_BAR(progress));
					while (gtk_events_pending ())gtk_main_iteration();
					}

				    if(entity->type == MPD_INFO_ENTITY_TYPE_SONG){
				    glist = g_slist_append(glist, g_strdup(entity->info.song->file));
				    mpd_freeInfoEntity(entity);
				    }
				    }
				}
				
		}while(gtk_tree_model_iter_next(model, &iter));

	if(glist != NULL)
	
	do{
	    i++;
	    if(!(i % 50))
		{
		gtk_progress_bar_pulse(GTK_PROGRESS_BAR(progress));
		while (gtk_events_pending ())gtk_main_iteration();
		}
	    mpd_sendAddCommand(connection,glist->data);
		check_error();
	    mpd_finishCommand(connection);
		check_error();
	    /* free the entry.. I asume g_slist_free doesnt do that */
	    g_free(glist->data);
	    }
	while((glist = g_slist_next(glist)));
	/* free the complete list */
	g_slist_free(glist);
	stop_progress();
	}

void load_songs_with_filter()
	{
	mpd_InfoEntity *entity;
	gchar *entryb,*buf = NULL;
	GPatternSpec *spec;
	gtk_list_store_clear(curlist);
	GtkWidget *progress= start_progress("Loading songs in current playlist");
	int option = gtk_option_menu_get_history(GTK_OPTION_MENU(glade_xml_get_widget(xml, "optionmenufilter")));
	GtkWidget *entry = glade_xml_get_widget(xml, "entryfilter");
	int i=0, rate = 50;
	/* if there is a playlistlength set the update rate to every 2.5 % */
	if(status->playlistLength != -1) rate = (int)(status->playlistLength/40 + 1);
	/* this is needed to get the right number of songs in the playlist */
	if(status != NULL) mpd_freeStatus(status);
	status = mpd_getStatus(connection);
	check_error();
	
	/* create the compare spec..  all uppercast */
	entryb = g_strdup_printf("*%s*",  gtk_entry_get_text(GTK_ENTRY(entry)));
	buf = g_utf8_strup(entryb, -1);
	spec = g_pattern_spec_new(buf);
	g_free(entryb);
	g_free(buf);
	mpd_sendPlaylistInfoCommand(connection, -1);
	if(check_error())
	    {
	    insetting.update_timeout = TRUE;
	    return;
	    }
	while((entity = mpd_getNextInfoEntity(connection)))
			{
			GtkTreeIter iter;
			if(check_error()) return;
			buf = NULL; /* if an tag can't be converted propperly ..  I wanna know */
			if(check_error())
			    {
			    insetting.update_timeout = TRUE;
			    return;
			    }
			if((i % rate)==0)
				{
				if(connection->version[1] >= 9)
				    {
				    gchar *buf = g_strdup_printf("%.1lf%% done", (double)(i/(double)status->playlistLength)*100);
				    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progress), (i/(double)status->playlistLength));
				    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progress), buf);
				    g_free(buf);
				    }
				else gtk_progress_bar_pulse(GTK_PROGRESS_BAR(progress));
				while (gtk_events_pending ())gtk_main_iteration();
				}
			if(entity->type == MPD_INFO_ENTITY_TYPE_SONG)
			{
			if(option == 0  && entity->info.song->title != NULL)buf = g_locale_to_utf8(entity->info.song->title, -1, NULL ,NULL ,NULL);
			else if(option == 1 && entity->info.song->artist != NULL) buf = g_locale_to_utf8(entity->info.song->artist, -1, NULL ,NULL ,NULL);
			else if (option == 2 && entity->info.song->album != NULL) buf = g_locale_to_utf8(entity->info.song->album, -1, NULL, NULL, NULL);
			else if (option == 3 && entity->info.song->file != NULL) buf = g_locale_to_utf8(entity->info.song->file, -1, NULL, NULL, NULL);
			else if(option == 4)
					{
						GString *string = g_string_new("");
						if(entity->info.song->title != NULL) g_string_append(string, entity->info.song->title);
						if(entity->info.song->artist != NULL) g_string_append(string, entity->info.song->artist);
						if(entity->info.song->album != NULL) g_string_append(string, entity->info.song->album);						
						if(entity->info.song->file != NULL) g_string_append(string, entity->info.song->file);
						buf = g_locale_to_utf8(string->str,  -1, NULL ,NULL ,NULL);
						g_string_free(string, TRUE);
					}
			if(buf == NULL) buf = g_strdup("!#@$"); /* oeps */
			else
				{
				gchar *temp = g_utf8_strup(buf, -1);
				g_free(buf);
				buf = temp;
				}
			if(g_pattern_match_string(spec, buf) || !insetting.show_filter)
			{
			gtk_list_store_append(curlist, &iter);
			gtk_list_store_set(curlist, &iter, 0, i,4, FALSE,5,"green", -1);
			if(status->song == i && status->state != MPD_STATUS_STATE_STOP && status->state != MPD_STATUS_STATE_UNKNOWN) 	gtk_list_store_set(curlist, &iter,4, TRUE, -1);
	    	if(entity->info.song->title != NULL)
	    	    {
			gchar *utf8 =  g_locale_to_utf8(entity->info.song->title, -1, NULL ,NULL ,NULL);
		    gtk_list_store_set(curlist, &iter, 1, utf8, -1);
			g_free(utf8);
		    if(entity->info.song->artist != NULL)
			{
			gchar *utf8 =  g_locale_to_utf8(entity->info.song->artist, -1, NULL ,NULL ,NULL);
			gtk_list_store_set(curlist, &iter, 2, utf8, -1);
			g_free(utf8);
			}
		    if(entity->info.song->album != NULL)
			    {
				gchar *utf8 =  g_locale_to_utf8(entity->info.song->album, -1, NULL ,NULL ,NULL);
			    gtk_list_store_set(curlist, &iter, 3, utf8, -1);
				g_free(utf8);
			    }
		    }
		    else {
			    gchar *buf1 = g_path_get_basename(entity->info.song->file);
				gchar *utf8 =  g_locale_to_utf8(buf1, -1, NULL ,NULL ,NULL);
			    gtk_list_store_set(curlist, &iter, 1,utf8, -1);
				g_free(utf8);
			    g_free(buf1);
			 }			
			}
			}
			g_free(buf);
			mpd_freeInfoEntity(entity);
			i++;
			}
	stop_progress();
	g_free(spec);
	}


void playlist_row_activated(GtkWidget *wid)
	{
	GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(wid));
	GtkTreeIter iter;
	GtkTreeModel *model = GTK_TREE_MODEL(curlist);
	if(gtk_tree_selection_get_selected(selection,  &model,&iter))
	    {
		int song;
		gtk_tree_model_get(model, &iter, 0, &song, -1);
		mpd_sendPlayCommand(connection, song);
		check_error();
		mpd_finishCommand(connection);
		check_error();
	    }
	}

/* wrapper function to try something */
void add_selected()
	{
	add_selected_dirs();
	add_selected_files();
	}

void update_playlist_manager()
    {
    if(insetting.playlist_running)
	{	
	/* update hightlighted song */
	if(status->song != insetting.song)
	    {
	    GtkTreeIter iter;
	    GtkTreeModel *model = GTK_TREE_MODEL(curlist);
	    int i = 0;
	    if(gtk_tree_model_get_iter_first(model, &iter))
	    do
		{
		if(status->state != MPD_STATUS_STATE_STOP && status->state != MPD_STATUS_STATE_UNKNOWN)
		    {
		    gtk_tree_model_get(model, &iter, 0, &i, -1);
		    if(i == status->song) gtk_list_store_set(curlist, &iter, 4, TRUE,-1); 
		    else  gtk_list_store_set(curlist, &iter, 4, FALSE,-1);
		    }
		    else  gtk_list_store_set(curlist, &iter, 4, FALSE,-1);
		}
		while (gtk_tree_model_iter_next(model, &iter));
	    }
	if(status->playlist != insetting.playlist)    
	    {
		load_songs_with_filter();
	    }
	}
    }
