/* libmpdclient
 * (c)2003 by Qball Cow (Qball@Qball.homelinux.org)
 * This project's homepage is: http://www.musicpd.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glade/glade.h>
#include "libmpdclient.h"
#include "eggtrayicon.h"
#include "playlist.h"
 /**********************************************
 *  Some very experimental xosd code.				 			 	*
 * xosd is somewhat old (gtk 1 and no xinemera support (this is supported in the latest version) 	*
 * so I am gonna remove this probly in the future 			 	*
 * to have it anyway ./configure --enable-xosd wil enable it*
 **********************************************/

#ifdef XOSD
#include <xosd.h>
xosd *osd;
#endif
/* A define.. to make changes to the gui more easy */
#define TITLE_LENGTH 40

iset_struct insetting = { TRUE,  FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, -1, -1};

/* so I know when song changed and when to update/show the popup */
int song = -1;

/* scrolling title in main window */
struct 
	{
		char *name;
		int pos;
		int up;
	} scroll;


GladeXML *xmlplay;

/* the mpd connection */
mpd_Connection * connection = NULL;
mpd_Status *status = NULL;




/* for search this is just easy*/
GtkListStore *list;



/* with the env MPD_HOST and MPD_PORT you can overwrite the connection settings */
/* with env NO_AUTOCONNECT you can stop autoconnect */
int connect_to_mpd()
    {
	char *ip, *port;
	(const char *)ip = g_getenv("MPD_HOST");
	(const char *)port = g_getenv("MPD_PORT");
	/* if the connection exists close/free it */
	if(connection != NULL) mpd_closeConnection(connection);
	if((ip == NULL || port == NULL) && g_getenv("NO_AUTOCONNECT") == NULL && config.autoconnect && !insetting.last_error) 
				{			
				connection =  mpd_newConnection(config.ip, config.port, 300);
				}
	else if(ip == NULL || port == NULL)
			{
			GladeXML *xmlc = glade_xml_new(GLADE_PATH"playlist.glade", "connect_dialog", NULL);
			gtk_entry_set_text(GTK_ENTRY(glade_xml_get_widget(xmlc, "entryhost") ), config.ip);
			gtk_spin_button_set_value(GTK_SPIN_BUTTON(glade_xml_get_widget(xmlc, "spinport")), config.port);
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlc, "autoconnectb")), config.autoconnect);
			/* change the labels if it's a reconnect attempt */
			do
				{
				switch(gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xmlc, "connect_dialog"))))
					{
						case GTK_RESPONSE_CANCEL:
										exit(EXIT_SUCCESS);
						default:
									if(strlen(gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xmlc, "entryhost") ))) )
										{
											config.port = (int)gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(glade_xml_get_widget(xmlc, "spinport")));
											if(config.ip != NULL) g_free(config.ip);
											config.ip = g_strdup(gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xmlc, "entryhost"))));
											config.autoconnect = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlc, "autoconnectb")));
										}
						}
					}
					while(	!strlen(gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xmlc, "entryhost") ))));
					gtk_widget_destroy(glade_xml_get_widget(xmlc, "connect_dialog"));
					g_object_unref(xmlc);


			connection =  mpd_newConnection(config.ip, config.port, 300);
			}
	else connection =  mpd_newConnection(ip, atoi(port), 300);
	/* if connection failed error out.. */
	check_error();
	return 0;    
    }



int main(int argc, char **argv) {
    /* start the gtk main loop */
    gtk_init(&argc, &argv);
	/* set good defaults for the config struct */
	config.ip = g_strdup("localhost");
	config.port = 2100;
	config.autoconnect = FALSE;
	config.hide_mw = FALSE;

	read_config();
    if(connect_to_mpd()) return 1;

	/* add stock icons */
	stock_icons();
	/* Set up the xosd display and set font and location */
	/* this fails on xinemera (xosd problem, not mine) */
    #ifdef XOSD
    osd = xosd_create(1);
      if (osd == NULL)
          {
	    perror ("Could not create \"osd\"");
	    printf("Please recompile the package withouth --enable-xosd to disable xosd\n");
	    exit (1);
	  }
	
    xosd_set_timeout(osd, 6);
    xosd_set_font (osd, "-adobe-helvetica-bold-r-normal-*-*-240-*-*-p-*-iso8859-1");
    xosd_set_shadow_offset (osd, 2);
    xosd_set_pos (osd, XOSD_bottom);
    xosd_set_vertical_offset (osd, 48);
    xosd_display (osd, 0, XOSD_string, "Traymp Started.");
    #endif 
    

    /* create the tray */
    tray_init();

	create_player();
    /* let it update every x ms */
    insetting.update_timeout = TRUE;
	g_timeout_add(500,(GSourceFunc) update_tray, NULL);
    
    /* run the mainloop. */
    gtk_main();    
    write_config();
    return 0;
}

/** This is the main function..  the program resolves around this..  */
/* this function updates the main player, and system tray */
/* FIXME update function name to make more sence */
int update_tray()
		{
		mpd_InfoEntity *entity = NULL;
		GString *string;
		if(!insetting.update_timeout) return TRUE;
		if(connection->error) return TRUE;
		string = g_string_new("");

		if(status != NULL) mpd_freeStatus(status);	
		status = mpd_getStatus(connection);
		if(check_error())return TRUE;

	
		/*scrolling effect */
		/* This wil scroll the title if it's bigger than the entry box.*/
		/* it will wait 2 seconds at the beginning of the title*/
		if(scroll.name != NULL)
		if(strlen(scroll.name) > TITLE_LENGTH)
			{
			if(scroll.pos == 0 && scroll.up % 4 );/* wait 2 sec on first pos */
			else{
					gtk_entry_set_text(GTK_ENTRY(glade_xml_get_widget(xmlmw, "entry3")), &scroll.name[scroll.pos]);
					scroll.pos++;
					if(scroll.pos > (strlen(scroll.name)-(TITLE_LENGTH-2)))
							{
							 scroll.up = 1;
							 scroll.pos = 0;
							gtk_entry_set_text(GTK_ENTRY(glade_xml_get_widget(xmlmw, "entry3")), &scroll.name[scroll.pos]);
							}
					}
			scroll.up++;
			}
		/* update repeat and random toggle button */
		if(status->repeat != gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlmw, "rept"))))
				{
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlmw, "rept")), status->repeat);
				}
		if(connection->version[1] >= 9)
		    {		
		    if(status->random != gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlmw, "randt"))))
				{
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlmw, "randt")), status->random);
				}

		    }
		/* update volume slider */
		if(status->volume != MPD_STATUS_NO_VOLUME) gtk_range_set_value(GTK_RANGE(glade_xml_get_widget(xmlmw, "vol_slide")), status->volume);
		else gtk_widget_set_sensitive(glade_xml_get_widget(xmlmw, "vol_slide"), FALSE);

		/* update progress slider */
		if(status->totalTime != 0) gtk_range_set_value(GTK_RANGE(glade_xml_get_widget(xmlmw, "prog_slide")), 
												(double)status->elapsedTime/(double)status->totalTime);	
		else gtk_range_set_value(GTK_RANGE(glade_xml_get_widget(xmlmw, "prog_slide")), 0);	
		
//		if(insetting.playlist_running != gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlmw, "playmant")))) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlmw, "playmant")), insetting.playlist_running);
//		if(insetting.playlist_show != gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlmw, "playlistb")))) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlmw, "playlistb")), insetting.playlist_show);
		

		switch(status->state)
			{
			case MPD_STATUS_STATE_UNKNOWN:
						gtk_tooltips_set_tip((GtkTooltips *)tray_icon_tooltip,(GtkWidget *)tray_icon, "Unknown State", NULL);
//						g_string_free(string, TRUE);
						if(insetting.tray_running)gtk_image_set_from_stock(GTK_IMAGE(tray_icon_image), "traymp-tray", GTK_ICON_SIZE_BUTTON);
						gtk_image_set_from_stock(GTK_IMAGE(glade_xml_get_widget(xmlmw, "image_player")), "traymp-tray", GTK_ICON_SIZE_BUTTON);
						gtk_image_set_from_stock(GTK_IMAGE(glade_xml_get_widget(xmlmw, "playbi")), "media-play", GTK_ICON_SIZE_BUTTON);
						break;
//						return TRUE;
			case MPD_STATUS_STATE_STOP:
						gtk_tooltips_set_tip((GtkTooltips *)tray_icon_tooltip,(GtkWidget *)tray_icon, "Playing Stopped", NULL);
//						g_string_free(string, TRUE);
						if(insetting.tray_running)gtk_image_set_from_stock(GTK_IMAGE(tray_icon_image), "traymp-tray", GTK_ICON_SIZE_BUTTON);
						gtk_image_set_from_stock(GTK_IMAGE(glade_xml_get_widget(xmlmw, "image_player")), "traymp-tray", GTK_ICON_SIZE_BUTTON);
						gtk_image_set_from_stock(GTK_IMAGE(glade_xml_get_widget(xmlmw, "playbi")), "media-play", GTK_ICON_SIZE_BUTTON);
						break;
//						return TRUE;
			case MPD_STATUS_STATE_PLAY:
					g_string_append(string,"Playing\n");
						if(insetting.tray_running)gtk_image_set_from_stock(GTK_IMAGE(tray_icon_image), "traymp-play", GTK_ICON_SIZE_BUTTON);
						gtk_image_set_from_stock(GTK_IMAGE(glade_xml_get_widget(xmlmw, "image_player")), "traymp-play", GTK_ICON_SIZE_BUTTON);
						gtk_image_set_from_stock(GTK_IMAGE(glade_xml_get_widget(xmlmw, "playbi")), "media-pause", GTK_ICON_SIZE_BUTTON);
					break;
			case MPD_STATUS_STATE_PAUSE:
					g_string_append(string,"Paused\n");
						if(insetting.tray_running)gtk_image_set_from_stock(GTK_IMAGE(tray_icon_image),"traymp-pause", GTK_ICON_SIZE_BUTTON);
						gtk_image_set_from_stock(GTK_IMAGE(glade_xml_get_widget(xmlmw, "image_player")), "traymp-pause", GTK_ICON_SIZE_BUTTON);
						gtk_image_set_from_stock(GTK_IMAGE(glade_xml_get_widget(xmlmw, "playbi")), "media-play", GTK_ICON_SIZE_BUTTON);
					break;
			default: break;
			}

		if(status->state == MPD_STATUS_STATE_PLAY || status->state == MPD_STATUS_STATE_PAUSE)
		{
		/* get the song */
		mpd_sendPlaylistInfoCommand(connection, status->song);
		entity = mpd_getNextInfoEntity(connection);
		if(check_error()) return TRUE;
		g_string_append_printf(string, "  Progress: \t%i%% (%02i:%02i/%02i:%02i)\n", (int)((status->elapsedTime/(double)status->totalTime)*100),
					(int)(status->elapsedTime/60), (int)(status->elapsedTime)-(int)(status->elapsedTime/60)*60,
					(int)(status->totalTime/60), (int)(status->totalTime)-(int)(status->totalTime/60)*60
					);
		if(status->state == MPD_STATUS_STATE_PLAY || status->state == MPD_STATUS_STATE_PAUSE)
				{
				char *buf;
				buf = g_strdup_printf("%02i:%02i", (int)(status->elapsedTime/60), (int)(status->elapsedTime)-(int)(status->elapsedTime/60)*60);
				gtk_entry_set_text(GTK_ENTRY(glade_xml_get_widget(xmlmw, "entry2")), buf);
				g_free(buf);
				}
		else gtk_entry_set_text(GTK_ENTRY(glade_xml_get_widget(xmlmw, "entry2")), "00:00");
		if((entity->info.song->artist == NULL || entity->info.song->title == NULL))
				{
				gchar *buf = g_path_get_basename((const gchar *)entity->info.song->file);
				g_string_append_printf(string, "  Filename:\t%s", buf);
				g_free(buf);
				}
		else {
				g_string_append_printf(string, "  Title:\t\t%s\n  Artist:\t\t%s", entity->info.song->title, entity->info.song->artist);
				if(entity->info.song->album != NULL) g_string_append_printf(string, "\n  Album:\t\t%s", entity->info.song->album);
				if(entity->info.song->track != NULL ) g_string_append_printf(string, "\n  Track:\t\t%s", entity->info.song->track);
				
				}
		gtk_tooltips_set_tip((GtkTooltips *)tray_icon_tooltip,(GtkWidget *)tray_icon, string->str, NULL);
		gtk_tooltips_set_tip((GtkTooltips *)tray_icon_tooltip,(GtkWidget *)glade_xml_get_widget(xmlmw, "entry3"), string->str, NULL);
		{
		gchar *buf = g_strdup_printf(" remaining time: %02i:%02i", (int)((status->totalTime - status->elapsedTime)/60), 
										(int)(status->totalTime - status->elapsedTime)-((status->totalTime - status->elapsedTime)/60)*60);
		gtk_tooltips_set_tip((GtkTooltips *)tray_icon_tooltip,(GtkWidget *)glade_xml_get_widget(xmlmw, "entry2"), buf, NULL);			
		g_free(buf);
		}
		}

	
		if(status->state == MPD_STATUS_STATE_PLAY && insetting.song != status->song)
		    {
		    if(1)//insetting.song > -1 && entity != NULL)
		    {
		    gchar *buf, *path;
			if(scroll.name != NULL) g_free(scroll.name);
			scroll.pos = 0;scroll.up = 1;
		    if(entity->info.song->title == NULL || entity->info.song->artist == NULL)
			{
			path = 	g_path_get_basename((const gchar *)entity->info.song->file);
			#ifdef XOSD
			buf = g_strdup_printf("Playing: %s", path);
			xosd_display(osd, 0, XOSD_string, buf);
			g_free(buf);
			#endif
			buf = g_strdup(path);
			g_free(path);
			path = g_locale_to_utf8(buf, -1, NULL, NULL, NULL);						
			gtk_entry_set_text(GTK_ENTRY(glade_xml_get_widget(xmlmw, "entry3")), path);
			scroll.name = g_strdup(path);
			g_free(buf);
			g_free(path);
			}
		    else {
			#ifdef XOSD
			buf = g_strdup_printf("Playing: %s - %s", entity->info.song->artist, entity->info.song->title);
			xosd_display(osd, 0, XOSD_string, buf);
			g_free(buf);
			#endif		
			buf = g_strdup_printf("%s - %s", entity->info.song->artist, entity->info.song->title);
			path = g_locale_to_utf8(buf, -1, NULL, NULL, NULL);
			gtk_entry_set_text(GTK_ENTRY(glade_xml_get_widget(xmlmw, "entry3")), path);
			scroll.name = g_strdup(path);
			g_free(buf);
			g_free(path);
			}
		    }

		    }
		    else if( insetting.song != status->song)
			{
			gtk_entry_set_text(GTK_ENTRY(glade_xml_get_widget(xmlmw, "entry3")), "Traymp");
			}		    
			
		update_playlist_manager();
			
		/* update check stuff */
		insetting.song = status->song;
		insetting.playlist = status->playlist;
		if(status->state == MPD_STATUS_STATE_STOP || status->state == MPD_STATUS_STATE_UNKNOWN)
		    {
		    insetting.song = -1;
		    }

		g_string_free(string, TRUE);
		if(entity != NULL) mpd_freeInfoEntity(entity);
		return TRUE;
	}


/* play control functions, name is self explaining */
/* the update timeout makes sure there not executed during another command */
void next_song()
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	mpd_sendNextCommand(connection);
	mpd_finishCommand(connection);
	insetting.update_timeout = TRUE;
	}
void prev_song()
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	mpd_sendPrevCommand(connection);
	mpd_finishCommand(connection);
	insetting.update_timeout = TRUE;
	}
void stop_song()
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	mpd_sendStopCommand(connection);
	mpd_finishCommand(connection);
	insetting.update_timeout = TRUE;
	}

void pause_song()
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	mpd_sendPauseCommand(connection);
	mpd_finishCommand(connection);
	insetting.update_timeout = TRUE;
	}
void play_song()
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	if(connection->version[1] >= 9 ) mpd_sendPlayCommand(connection, MPD_PLAY_AT_BEGINNING);
	else  mpd_sendPlayCommand(connection, 1);
	mpd_finishCommand(connection);
	insetting.update_timeout = TRUE;
	}
void volume_up()
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	mpd_sendVolumeCommand(connection, 5);
	mpd_finishCommand(connection);
	insetting.update_timeout = TRUE;
	}
void volume_down()
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	mpd_sendVolumeCommand(connection, -5);
	mpd_finishCommand(connection);
	insetting.update_timeout = TRUE;
	}
void shuffle_pl()
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	mpd_sendShuffleCommand(connection);
	mpd_finishCommand(connection);
	insetting.update_timeout = TRUE;
	}

void repeat_pl()
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	mpd_sendRepeatCommand(connection, !status->repeat);
	mpd_finishCommand(connection);
	check_error();
	insetting.update_timeout = TRUE;	
	}
void repeat_pl_tb(GtkWidget *wid)
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid)) != status->repeat)
	{
	mpd_sendRepeatCommand(connection, !status->repeat);
	mpd_finishCommand(connection);
	check_error();
	}
	insetting.update_timeout = TRUE;	
	}

void random_pl()
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	mpd_sendRandomCommand(connection, !status->random);
	mpd_finishCommand(connection);
	check_error();
	insetting.update_timeout = TRUE;	
	}

void random_pl_tb(GtkWidget *wid)
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid)) != status->random)
	{
	mpd_sendRandomCommand(connection, !status->random);
	mpd_finishCommand(connection);
	check_error();
	}
	check_error();
	insetting.update_timeout = TRUE;	
	}

void set_volume()
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	mpd_sendVolumeCommand(connection, (int)(gtk_range_get_value(GTK_RANGE(glade_xml_get_widget(xmlmw, "vol_slide"))) - status->volume));
	mpd_finishCommand(connection);
	check_error();
	insetting.update_timeout = TRUE;
	}


void play_pause_song()
	{
	if(!insetting.update_timeout) return;
	insetting.update_timeout = FALSE;
	if(status->state == MPD_STATUS_STATE_PLAY || status->state == MPD_STATUS_STATE_PAUSE)
		{
		mpd_sendPauseCommand(connection);
		}
	else
	    {
	    	if(connection->version[1] >= 9 ) mpd_sendPlayCommand(connection, MPD_PLAY_AT_BEGINNING);
		else  mpd_sendPlayCommand(connection, 1);
	    }
	mpd_finishCommand(connection);
	insetting.update_timeout = TRUE;
	}

int check_error()
	{
	if(connection->error)
		{
		GladeXML *xmler;
		gchar *buf = g_strdup_printf("<span foreground=\"dark red\">%s</span>",connection->errorStr);
		xmler = glade_xml_new(GLADE_PATH"playlist.glade", "error_win", NULL);
		gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xmler, "error_lb")), buf);
		g_free(buf);
		if(connection->error ==  MPD_ERROR_TIMEOUT ||
			connection->error ==  MPD_ERROR_UNKHOST ||
			connection->error ==  MPD_ERROR_CONNPORT ||
			connection->error ==  MPD_ERROR_NOTMPD ||
			connection->error ==  MPD_ERROR_NORESPONSE	 ||
			connection->error ==  MPD_ERROR_CONNCLOSED)
			 gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xmler, "errmsg")),"There was an error comunicating to the mpd daemon. \nPlease check the connection.");
			 gtk_widget_show(glade_xml_get_widget(xmler, "errmsg"));
			/* This !!ONLY!! can be trusted @ program startup. */
			/* xmlmw is a good indicator for this.. after the gui is started.. you could be anywhere*/
			/* and you just can't go reconnect */
			if(xmlmw == NULL)
			{
			 gtk_widget_show(glade_xml_get_widget(xmler, "recon"));
			}
		switch(gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xmler, "error_win"))))
		    {
		    case GTK_RESPONSE_YES:
			    gtk_widget_destroy(glade_xml_get_widget(xmler, "error_win"));
			    g_object_unref(xmler);
			    /* connection failed, so it might be wise to turn autoconnection off */
			    config.autoconnect = FALSE;
			    connect_to_mpd();
			    return 1;
		    default: exit(EXIT_FAILURE);
		    }
		}
	else return 0;
	}

void show_playlist_manager()
    {
    gboolean state = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlmw, "playmantb")));
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlmw, "playmantb")), !state);
    }

void show_playlist_manager_tb()
    {
    if(!insetting.update_timeout) return;
    if(insetting.playlist_running != gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xmlmw, "playmantb"))))
	{
	if(insetting.playlist_running) playlist_manager_quit();
	else playlist_manager();
	}
    }


/********************************************************************/
/*  STOCK ICONS  - this function makes stock icons from the icons I use in traymp. 	*/
/* so potential theme makers can skin traymp (if they see something in traymp  			*/
/*********************************************************************/
void stock_icons()
    {
    GtkIconFactory *factory;
    GtkIconSet *icons;
    GtkIconSource *icon_source;

    /* testing icon factory.. hope it works a little */
    factory = gtk_icon_factory_new();
    /* random icon */
    icons = gtk_icon_set_new();
    icon_source = gtk_icon_source_new();
    gtk_icon_source_set_filename(icon_source, PIXMAP_PATH"/media-play.png");
    gtk_icon_set_add_source(icons, icon_source);
    gtk_icon_factory_add(factory, "media-play", icons);

    icons = gtk_icon_set_new();
    icon_source = gtk_icon_source_new();
    gtk_icon_source_set_filename(icon_source, PIXMAP_PATH"/media-pause.png");
    gtk_icon_set_add_source(icons, icon_source);
    gtk_icon_factory_add(factory, "media-pause", icons);

    icons = gtk_icon_set_new();
    icon_source = gtk_icon_source_new();
    gtk_icon_source_set_filename(icon_source, PIXMAP_PATH"/media-stop.png");
    gtk_icon_set_add_source(icons, icon_source);
    gtk_icon_factory_add(factory, "media-stop", icons);

    icons = gtk_icon_set_new();
    icon_source = gtk_icon_source_new();
    gtk_icon_source_set_filename(icon_source, PIXMAP_PATH"/media-prev.png");
    gtk_icon_set_add_source(icons, icon_source);
    gtk_icon_factory_add(factory, "media-prev", icons);
    gtk_icon_factory_add_default (factory);

    icons = gtk_icon_set_new();
    icon_source = gtk_icon_source_new();
    gtk_icon_source_set_filename(icon_source, PIXMAP_PATH"/media-next.png");
    gtk_icon_set_add_source(icons, icon_source);
    gtk_icon_factory_add(factory, "media-next", icons);
    gtk_icon_factory_add_default (factory);

    icons = gtk_icon_set_new();
    icon_source = gtk_icon_source_new();
    gtk_icon_source_set_filename(icon_source, PIXMAP_PATH"/tray.png");
    gtk_icon_set_add_source(icons, icon_source);
    gtk_icon_factory_add(factory, "traymp-tray", icons);
    gtk_icon_factory_add_default (factory);

    icons = gtk_icon_set_new();
    icon_source = gtk_icon_source_new();
    gtk_icon_source_set_filename(icon_source, PIXMAP_PATH"/tray-pause.png");
    gtk_icon_set_add_source(icons, icon_source);
    gtk_icon_factory_add(factory, "traymp-pause", icons);
    gtk_icon_factory_add_default (factory);

    icons = gtk_icon_set_new();
    icon_source = gtk_icon_source_new();
    gtk_icon_source_set_filename(icon_source, PIXMAP_PATH"/tray-play.png");
    gtk_icon_set_add_source(icons, icon_source);
    gtk_icon_factory_add(factory, "traymp-play", icons);
    gtk_icon_factory_add_default (factory);
    }




